﻿<Serializable()>
Public Class Cls_BrightnessControllerCapability
    Inherits Cls_Capability

    ' Properties going to JSON
    Public Property properties As New Cls_BrightnessControllerProperties

    'Properties for internal use
    Public AlexaDirectives As String = "   name: SetBrightness" & vbCrLf &
                                       "Payload.brightness: 50" & vbCrLf &
                                       "      Or: " & vbCrLf &
                                       "   name: AdjustBrightness" & vbCrLf &
                                       "Payload.brightnessDelta: -25"



    Public Sub New()
        MyBase.interface = "Alexa.BrightnessController"
        Me.properties.supported.Add(New Cls_Supported("brightness"))
    End Sub
End Class


<Serializable()>
Public Class Cls_BrightnessControllerProperties
    Public Property supported As New List(Of Cls_Supported)
    Public Property proactivelyReported As Boolean = False
    Public Property retrievable As Boolean = False
    Public Property nonControllable As TriState = False
End Class



'  "type" "AlexaInterface",
'  "interface": "Alexa.BrightnessController",
'  "version": "3",
'  "properties": {
'    "supported": [
'      {
'        "name": "brightness"
'      }
'    ],
'    "proactivelyReported": true,
'    "retrievable": true
