﻿<Serializable()>
Public Class Cls_ChannelControllerCapability
    Inherits Cls_Capability

    ' Properties going to JSON
    Public Property properties As New Cls_ChannelControllerProperties

    'Properties for internal use
    Public AlexaDirectives As String = "   name: ChangeChannel" & vbCrLf &
                                       "Payload: channel.number: '1234'" & vbCrLf &
                                       "      Or channelCount: -5"



    Public Sub New()
        MyBase.interface = "Alexa.ChannelController"
        Me.properties.supported.Add(New Cls_Supported("channel"))
    End Sub
End Class

<Serializable()>
Public Class Cls_ChannelControllerProperties
    Public Property supported As New List(Of Cls_Supported)
    Public Property proactivelyReported As Boolean = False
    Public Property retrievable As Boolean = False
    Public Property nonControllable As Boolean = False
End Class


'"type" "AlexaInterface",
'"interface": "Alexa.ChannelController",
'"version": "3",
'"properties": {
'  "supported": [
'    {
'      "name": "channel"
'    }
'  ]
'}


' REQUEST FROM ALEXA

'"payload" {
'  "channel": {
'      "number": "1234",
'      "callSign": "KSTATION1",
'      "affiliateCallSign": "KSTATION2",
'      "uri": "someUrl"
'  },
'  "channelMetadata": {
'      "name": "Alternate Channel Name",
'      "image": "urlToImage"
'  }
'}