﻿<Serializable()>
Public Class Cls_ColorTemperatureControllerCapability
    Inherits Cls_Capability

    ' Properties going to JSON
    Public Property properties As New Cls_ColorTemperatureControllerProperties

    'Properties for internal use
    Public AlexaDirectives As String = "   name: SetColorTemperature" & vbCrLf &
                                       "Payload: colorTemperatureInKelvin: 3500" & vbCrLf &
                                       " or: " & vbCrLf &
                                       "   name: DecreaseColorTemperature" & vbCrLf &
                                       " or: " & vbCrLf &
                                       "   name: IncreaseColorTemperature"

    Public Sub New()
        MyBase.interface = "Alexa.ColorTemperatureController"
        MyBase.Set_HelpPage("http://developer.amazon.com/de/docs/device-apis/alexa-colortemperaturecontroller.html")

        Me.properties.supported.Add(New Cls_Supported("colorTemperatureInKelvin"))
    End Sub
End Class

<Serializable()>
Public Class Cls_ColorTemperatureControllerProperties
    Public Property supported As New List(Of Cls_Supported)
    Public Property proactivelyReported As Boolean = False
    Public Property retrievable As Boolean = False
    Public Property nonControllable As Boolean = False
End Class

'"type" "AlexaInterface",
'"interface": "Alexa.ColorTemperatureController",
'"version": "3",
'"properties": {
'  "supported": [
'    {
'      "name": "colorTemperatureInKelvin"
'    }
'  ],
'  "proactivelyReported": true,
'  "retrievable": true