﻿<Serializable()>
Public Class Cls_InputControllerCapability
    Inherits Cls_Capability

    ' Properties going to JSON
    Public Property Inputs As New List(Of Cls_InputControllerInputs)


    'Properties for internal use

    ' Public All_Inputs As New List(Of String)
    <NonSerialized()> Public lv As ListView
    <NonSerialized()> Private ListviewInit As Boolean = False

    Public Sub New()
        MyBase.interface = "Alexa.InputController"
        'All_Inputs.AddRange({"AUX 1", "AUX 2", "AUX 3", "AUX 4", "AUX 5", "AUX 6",
        '                    "AUX 7", "BLURAY", "CABLE", "CD", "COAX 1", "COAX 2",
        '                    "COMPOSITE 1", "DVD", "GAME", "HD RADIO", "HDMI 1", "HDMI 2",
        '                    "HDMI 3", "HDMI 4", "HDMI 5", "HDMI 6", "HDMI 7", "HDMI 8",
        '                    "HDMI 9", "HDMI 10", "HDMI ARC", "INPUT 1", "INPUT 2",
        '                    "INPUT 3", "INPUT 4", "INPUT 5", "INPUT 6", "INPUT 7",
        '                    "INPUT 8", "INPUT 9", "INPUT 10", "IPOD", "LINE 1",
        '                    "LINE 2", "LINE 3", "LINE 4", "LINE 5", "LINE 6", "LINE 7",
        '                    "MEDIA PLAYER", "OPTICAL 1", "OPTICAL 2", "PHONO",
        '                    "PLAYSTATION", "PLAYSTATION 3", "PLAYSTATION 4", "SATELLITE",
        '                    "SMARTCAST", "TUNER", "TV", "USB DAC", "VIDEO 1", "VIDEO 2",
        '                    "VIDEO 3", "XBOX"})
    End Sub

    Public Sub FillListView()
        If IsNothing(lv) Then Exit Sub

        ListviewInit = True
        lv.Items.Clear()
        Dim li As ListViewItem
        For Each l As String In All_Inputs
            li = lv.Items.Add(l)
            li.Name = l
        Next

        Dim li2 As ListViewItem()
        For Each n As Cls_InputControllerInputs In Inputs
            li2 = lv.Items.Find(n.name, True)
            li2(0).Checked = True
        Next
        ListviewInit = False
    End Sub

    Public Sub HandleListviewCheck()
        If ListviewInit = True Then Exit Sub
        If IsNothing(lv) Then Exit Sub
        Inputs.Clear()
        For Each li As ListViewItem In lv.Items
            If li.Checked Then
                Inputs.Add(New Cls_InputControllerInputs(li.Text))
            End If
        Next
    End Sub
End Class

<Serializable()>
Public Class Cls_InputControllerInputs
    Public Property name As String

    Public Sub New(n As String)
        name = n
    End Sub
End Class


'"inputs" [
'               {
'                 "name": "HDMI 1"
'               },
'               {
'                 "name": "HDMI 2"
'               }
