﻿Imports System.Text.Json


Public Enum e_FriendlyName_Type
    asset
    text
End Enum


<Serializable()>
Public Class Cls_ModeControllerCapability
    ' Inherits Cls_Capability

    '   type
    '   interface
    '   instance
    '   properties
    '   properties.supported []
    '   properties.supported.name
    '   properties.retrievable
    '   properties.proactivelyReported
    '   properties.nonControllable

    '   capabilityResources
    '   capabilityResources.friendlyNames
    '   capabilityResources.friendlyNames.@type
    '   capabilityResources.friendlyNames.value
    '   capabilityResources.friendlyNames.value.text
    '   capabilityResources.friendlyNames.value.locale

    '   configuration
    '   configuration.ordered
    '   configuration.supportedModes []
    '   configuration.supportedModes.value
    '   configuration.supportedModes.modeResources
    '   configuration.supportedModes.modeResources.friendlyNames []
    '   configuration.supportedModes.modeResources.friendlyNames.text
    '   configuration.supportedModes.modeResources.friendlyNames.locale




    ' Properties going to JSON
    Public Property type As String = "AlexaInterface"
    Public Property [interface] As String = "Alexa.ModeController"
    Public Property instance As String = String.Empty
    Public Property version As String = "3"
    Public Property capabilityResources As New Cls_CapabilityResources
    Public Property properties As New Cls_ModeControllerProperties
    Public Property configuration As New Cls_ModeConfiguration

    'Properties for internal use

    ' Public All_Inputs As New List(Of String)
    <NonSerialized()> Public lv As ListView
    <NonSerialized()> Private ListviewInit As Boolean = False

    Public Sub New()
        Globals.test(Me)
    End Sub

    Public AlexaHelpPage As String
    Public MyClassname As String

    Public Sub Set_HelpPage(s As String)
        AlexaHelpPage = s
    End Sub

    Public Function GetClassName() As String
        Return MyClassname
    End Function

    Public Function SetClassName(s As String) As String
        MyClassname = s
        Return s
    End Function
End Class


<Serializable()>
Public Class Cls_CapabilityResources
    Public Property friendlyNames As New List(Of Cls_FriendlyNames)
End Class

<Serializable()>
Public Class Cls_ModeConfiguration
    Public Property ordered As Boolean = False
    Public Property supportedModes As New List(Of Cls_SupportedModes)
End Class

<Serializable()>
Public Class Cls_SupportedModes
    Public Property value As String
    Public Property modeResources As New Cls_ModeResources
End Class

<Serializable()>
Public Class Cls_ModeResources
    Public Property friendlyNames As New List(Of Cls_FriendlyNames)
End Class


<Serializable()>
Public Class Cls_ModeControllerProperties
    Public Property supported As New List(Of Cls_Supported)
    Public Property proactivelyReported As Boolean = False
    Public Property retrievable As Boolean = False
    Public Property nonControllable As Boolean = False

    Public Sub New()
        supported.Add(New Cls_Supported("mode"))
    End Sub
End Class




<Serializable()>
Public Class Cls_FriendlyNames
    <Serialization.JsonPropertyName("@type")>
    Public Property type As String
    Public Property value As New Cls_Value

    Public Sub New(m_type As e_FriendlyName_Type, m_value As String)
        If m_type = e_FriendlyName_Type.asset Then
            Me.type = "asset"
            Me.value.assetId = m_value
        Else
            Me.type = "text"
            Me.value.text = m_value
            Me.value.locale = "de-DE"
        End If
    End Sub


End Class

<Serializable()>
Public Class Cls_Value
    Public Property assetId As String
    Public Property text As String
    Public Property locale As String
End Class



'"@type" "asset",
'"value": {
'  "assetId": "Alexa.Setting.WaterTemperature"
'}

'{
'  "@type": "text",
'  "value": {
'    "text": "wash temperature",
'    "locale": "en-US"
'  }

