﻿<Serializable()>
Public Class Cls_ThermostatControllerCapability
    Inherits Cls_Capability

    ' Properties going to JSON
    Public Property properties As New Cls_ThermostatControllerProperties
    Public Property configuration As New Cls_ThermostatControllerConfiguration

    'Properties for internal use
    Public AlexaDirectives As String = "  "

    Public Sub New()
        MyBase.interface = "Alexa.ThermostatController"
        Me.properties.supported.Add(New Cls_Supported("targetSetpoint"))
        Me.properties.supported.Add(New Cls_Supported("lowerSetpoint"))
        Me.properties.supported.Add(New Cls_Supported("upperSetpoint"))
        Me.properties.supported.Add(New Cls_Supported("thermostatMode"))

        Me.configuration.supportedModes.Add("HEAT")
        Me.configuration.supportedModes.Add("COOL")
        Me.configuration.supportedModes.Add("AUTO")
    End Sub
End Class

<Serializable()>
Public Class Cls_ThermostatControllerProperties
    Public Property supported As New List(Of Cls_Supported)
    Public Property proactivelyReported As Boolean = False
    Public Property retrievable As Boolean = False
    Public Property nonControllable As Boolean = False
End Class

<Serializable()>
Public Class Cls_ThermostatControllerConfiguration
    Public Property supportsScheduling As Boolean = True
    Public Property supportedModes As New List(Of String)
End Class

'"capabilities" [{
'    "type": "AlexaInterface",
'    "interface": "Alexa.ThermostatController",
'    "version": "3",
'    "properties": {
'      "supported": [{
'          "name": "targetSetpoint"
'        },
'        {
'          "name": "lowerSetpoint"
'        },
'        {
'          "name": "upperSetpoint"
'        },
'        {
'          "name": "thermostatMode"
'        }
'      ],
'      "proactivelyReported": true,
'      "retrievable": true
'    },
'    "configuration": {
'      "supportsScheduling": false,
'      "supportedModes": [
'        "HEAT",
'        "COOL",
'        "AUTO"
'      ]
'    }
'  },