﻿Imports System.ComponentModel
Imports System.IO

Public Class Form1
    Public SelectedEndPoint As Cls_Endpoint             ' The current selected Endpoint in the Listview
    Public Init = True                                  ' Prevent control redraws during startup
    Private CategorieCheckEnabled As Boolean = True     ' Prevent Doing Event code while setting checkmarks from program
    Private OriginalJSON As String                      'JSON from loaded file, used to check if needs to be saved on exit
    Private SelectedModeControllser As Cls_ModeControllerCapability


    Public Sub New()
        ' Dieser Aufruf ist für den Designer erforderlich.
        InitializeComponent()
    End Sub


#Region "Form Events"
    Private Sub Form1_Load(sender As Object, e As EventArgs) Handles MyBase.Load
        'TODO: Load Class

        'IF CLASS NOT LOADED:
        myResponses = New Cls_ResponseObjects
        myResponses.event = New Cls_event
        myResponses.event.header = New Cls_Header
        myResponses.event.payload = New Cls_Payload
        lblWeb.Text = String.Empty

        Globals.Init()
        For Each kv As KeyValuePair(Of String, String) In AllCategories
            Dim li As ListViewItem = LV_categ.Items.Add(kv.Value)
            li.Tag = kv.Key
        Next




        ' Dim a = myResponses.CreateJSON
        Try
            Dim fred As String = Path.GetTempPath() & "SavedAlexaDevices.adg"
            If System.IO.File.Exists(fred) Then
                LoadFile(fred)
            End If
        Catch ex As Exception

        End Try

        Init = False

        If lv1.Items.Count Then
            lv1.Items(0).Selected = True
        End If
        ToolStripTextBox1.Text = My.Settings.ListenPort.ToString
        lblWeb.Text = TimeOfDay & " :-> Starting Session"
        Webserver2.StartWebServer()

    End Sub

    Private Sub Form1_Closing(sender As Object, e As CancelEventArgs) Handles Me.Closing
        If OriginalJSON <> myResponses.CreateJSON(TransferJSON) Then
            Dim res As MsgBoxResult = MsgBox("Die Daten wurden verändert, wollen Sie diese Speichern?", vbYesNo, "Alexa Device Generator")
            If res = MsgBoxResult.Yes Then
                SpeichernUnterToolStripMenuItem_Click(Nothing, Nothing)
            End If
        End If
        e.Cancel = False
    End Sub

    ' Stop The Web Browser and save File
    Private Sub Form1_FormClosing(sender As Object, e As FormClosingEventArgs) Handles Me.FormClosing
        Timer1.Enabled = False
        Webserver2.StopWebserver()
        Serialize(Path.GetTempPath() & "SavedAlexaDevices.adg")
    End Sub
#End Region


#Region "Add / Remove Devices buttons"
    'Neues Gerät
    Private Sub btn_NewDevice_Click(sender As Object, e As EventArgs) Handles btn_NewDevice.Click
        Dim li As New ListViewItem
        li = lv1.Items.Add("New item")
        Dim NewEndpoint As New Cls_Endpoint
        NewEndpoint.lvi = li
        NewEndpoint.endpointId = "NeuesGeraet"
        NewEndpoint.friendlyName = "Paul"
        NewEndpoint.description = "Dies ist ein Schalter"
        NewEndpoint.manufacturerName = "Soehnke M."
        '        NewEndpoint.displayCategories = "SWITCH"
        myResponses.event.payload.AddEndpoint(NewEndpoint)

        li.Tag = NewEndpoint
        li.Selected = True
    End Sub

    Private Sub btn_DeleteDevice_Click(sender As Object, e As EventArgs) Handles btn_DeleteDevice.Click
        If lv1.SelectedItems.Count Then
            Dim li As ListViewItem
            li = lv1.SelectedItems(0)
            Dim o As Object = li.Tag
            Dim oo As Object
            For I As Integer = 1 To myResponses.event.payload.endpoints.Count
                oo = myResponses.event.payload.endpoints(I - 1)
                If o Is oo Then
                    myResponses.event.payload.endpoints.RemoveAt(I - 1)
                    Exit For
                End If
            Next
            lv1.Items.Remove(li)
        End If
    End Sub

#End Region


#Region "Device Listview Events"
    'Gerät wird im Listview angewählt
    Private Sub lv1_SelectedIndexChanged(sender As Object, e As EventArgs) Handles lv1.SelectedIndexChanged
        lv_inputs.Visible = False
        If lv1.SelectedItems.Count Then
            Dim li As ListViewItem = lv1.SelectedItems(0)
            Dim ep As Cls_Endpoint = li.Tag
            SplitContainer2.Panel1.Visible = True

            SelectedEndPoint = ep

            Me.txt_description.DataBindings.Clear()
            Me.txt_description.DataBindings.Add(New System.Windows.Forms.Binding("Text", ep, "Description", False, DataSourceUpdateMode.OnPropertyChanged))
            Me.txt_manufacturer.DataBindings.Clear()
            Me.txt_manufacturer.DataBindings.Add(New System.Windows.Forms.Binding("Text", ep, "manufacturerName", False, DataSourceUpdateMode.OnPropertyChanged))
            Me.txt_Endpoint.DataBindings.Clear()
            Me.txt_Endpoint.DataBindings.Add(New System.Windows.Forms.Binding("Text", ep, "endpointId", False, DataSourceUpdateMode.OnPropertyChanged))
            Me.txt_name.DataBindings.Clear()
            Me.txt_name.DataBindings.Add(New System.Windows.Forms.Binding("Text", ep, "friendlyName", False, DataSourceUpdateMode.OnPropertyChanged))

            'clear all Checkboxes
            CategorieCheckEnabled = False
            For Each item As ListViewItem In LV_categ.Items
                item.Checked = False
            Next
            For Each kv In ep.mdisplayCategories
                For Each item As ListViewItem In LV_categ.Items
                    If item.Tag = kv.Key Then
                        item.Checked = True
                    End If
                Next
            Next
            CategorieCheckEnabled = True

            RebuildAvailableCapabilities()
            'lv_AvailableCapabilities.Items.Clear()
            'For Each kv As KeyValuePair(Of String, ClsFunctionTypes) In ImplementedFunctions
            '    li = lv_AvailableCapabilities.Items.Add(kv.Value.DisplayName)
            '    li.Tag = kv.Value
            'Next


            'lv_EnabledCapabilities.Items.Clear()
            'For Each ic As Object In SelectedEndPoint.capabilities
            '    Dim s As String = ic.GetClassName
            '    Dim ft As ClsFunctionTypes = ImplementedFunctions(s)
            '    li = lv_EnabledCapabilities.Items.Add(ft.DisplayName)
            '    li.Tag = ic
            '    Remove_From_lv_AvailableCapabilities(ft.FunctionClass)
            'Next
        Else
            SplitContainer2.Panel1.Visible = False

        End If
        lv_EnabledCapabilities_SelectedIndexChanged(Nothing, Nothing)
    End Sub

    Private Sub lv1_ItemChecked(sender As Object, e As ItemCheckedEventArgs) Handles lv1.ItemChecked
        If Init = True Then Exit Sub
        Try
            e.Item.Tag.enabled = e.Item.Checked
        Catch ex As Exception

        End Try
    End Sub

#End Region


#Region "Capabilities"

    Private Sub RebuildAvailableCapabilities()
        Dim li As ListViewItem = lv1.SelectedItems(0)
        lv_AvailableCapabilities.Items.Clear()
        For Each kv As KeyValuePair(Of String, ClsFunctionTypes) In ImplementedFunctions
            li = lv_AvailableCapabilities.Items.Add(kv.Value.DisplayName)
            li.Tag = kv.Value
        Next

        lv_EnabledCapabilities.Items.Clear()
        For Each ic As Object In SelectedEndPoint.capabilities
            Dim s As String = ic.GetClassName
            Dim ft As ClsFunctionTypes = ImplementedFunctions(s)
            li = lv_EnabledCapabilities.Items.Add(ft.DisplayName)
            li.Tag = ic
            Remove_From_lv_AvailableCapabilities(ft.FunctionClass)
        Next
    End Sub

    Private Sub Remove_From_lv_AvailableCapabilities(ClassName As String)
        If ImplementedFunctions(ClassName).MultipleAllowed = False Then
            Dim li As ListViewItem = lv_AvailableCapabilities.FindItemWithText(ImplementedFunctions(ClassName).DisplayName)
            lv_AvailableCapabilities.Items.Remove(li)
        End If
    End Sub

    Private Sub btn_AddFunction_Click(sender As Object, e As EventArgs) Handles btn_AddFunction.Click

        If lv_AvailableCapabilities.SelectedItems.Count > 0 Then
            Dim implfunc As ClsFunctionTypes = lv_AvailableCapabilities.SelectedItems(0).Tag
            Dim newCapability As Object = implfunc.CreateNew(implfunc.FunctionClass)

            '  Dim newCapability As ICapabilyInterface = implfunc.CreateNew(implfunc.FunctionClass)
            SelectedEndPoint.capabilities.Add(newCapability)
            Dim li As ListViewItem = lv_EnabledCapabilities.Items.Add(implfunc.DisplayName)
            li.Tag = newCapability
            '            lv_EnabledCapabilities.Tag = newCapability
            Remove_From_lv_AvailableCapabilities(implfunc.FunctionClass)
        End If
    End Sub

    Private Sub btn_DeleteFunction_Click(sender As Object, e As EventArgs) Handles btn_DeleteFunction.Click
        If lv_EnabledCapabilities.SelectedItems.Count > 0 Then
            Dim o As Object = lv_EnabledCapabilities.SelectedItems(0).Tag
            For i As Integer = 1 To SelectedEndPoint.capabilities.Count
                Dim oo As Object = SelectedEndPoint.capabilities(i - 1)
                If o Is oo Then
                    SelectedEndPoint.capabilities.RemoveAt(i - 1)
                    Exit For
                End If
            Next
            RebuildAvailableCapabilities()
        End If
    End Sub


#End Region


#Region "Display Category"
    'checkbox wird bei der Kategorie geändert
    Private Sub LV_categ_ItemChecked(sender As Object, e As ItemCheckedEventArgs) Handles LV_categ.ItemChecked
        If CategorieCheckEnabled = False Then Exit Sub
        If Init = True Then Exit Sub

        SelectedEndPoint.mdisplayCategories.Clear()
        For Each i In LV_categ.CheckedIndices
            Dim li As ListViewItem = LV_categ.Items(i)
            SelectedEndPoint.mdisplayCategories.Add(li.Tag, li.Text)
        Next
    End Sub
#End Region


#Region "Timer für Log Anzeige"
    Private Sub Timer1_Tick(sender As Object, e As EventArgs) Handles Timer1.Tick
        If Webserver2.myLog.Count Then
            lblWeb.Text = lblWeb.Text & (vbCrLf & Webserver2.myLog(0))
            Webserver2.myLog.RemoveAt(0)
            lblWeb.SelectionStart = lblWeb.Text.Length
            lblWeb.ScrollToCaret()
        End If
    End Sub
#End Region


#Region "Validation of Text inputs"

    'Private Sub txt_Endpoint_KeyPress(sender As Object, e As KeyPressEventArgs) Handles txt_Endpoint.KeyPress
    '    Debug.Write("KeyPressed: " & Asc(e.KeyChar) & vbCrLf)
    '    If Not (Asc(e.KeyChar) = 8) Or (Asc(e.KeyChar) = 13) Then
    '        Dim allowedChars As String = "abcdefghijklmnopqrstuvwxyzABCDEFGHIJKLMNOPQRSTUVWXYZ1234567890_-=#;:?@&."
    '        If Not allowedChars.Contains(e.KeyChar.ToString.ToLower) Then
    '            e.KeyChar = ChrW(0)
    '            e.Handled = True
    '        End If
    '    End If
    'End Sub


    Private Sub txt_Endpoint_Validating(sender As Object, e As CancelEventArgs) Handles txt_Endpoint.Validating
        If Len(sender.text) > 128 Then
            MsgBox("EndpointID darf maximal 128 Zeichen lang sein")
            e.Cancel = True
            Exit Sub
        End If
        If Not isValidString(sender.text, "abcdefghijklmnopqrstuvwxyzABCDEFGHIJKLMNOPQRSTUVWXYZ1234567890_-=#;: ?@&.") Then
            MsgBox("EndpointID darf nur [a-z],[A-Z] sowie die Sonderzeichen _,-,=,#,;,:, ,?,@,&,. enthalten")
            e.Cancel = True

        End If
    End Sub

    Function isValidString(ByVal txt As String, ByVal validChars As String) As Boolean

        For i As Integer = 0 To txt.Length - 1
            If Not validChars.Contains(txt.Chars(i)) Then
                Return False
                Exit Function
            End If
        Next
        Return True
    End Function

#End Region


#Region "Menue"
    Private Sub SpeichernToolStripMenuItem_Click(sender As Object, e As EventArgs) Handles SpeichernToolStripMenuItem.Click
        Try
            Serialize(My.Settings.LastUsedFile)
            OriginalJSON = myResponses.CreateJSON(TransferJSON)
        Catch ex As Exception
            MsgBox(ex)
        End Try

    End Sub

    Private Sub SpeichernUnterToolStripMenuItem_Click(sender As Object, e As EventArgs) Handles SpeichernUnterToolStripMenuItem.Click
        SaveFileDialog1.InitialDirectory = My.Settings.LastUsedFile
        SaveFileDialog1.ShowDialog()
        If SaveFileDialog1.FileName <> String.Empty Then
            Serialize(SaveFileDialog1.FileName)
            My.Settings.LastUsedFile = SaveFileDialog1.FileName
            My.Settings.Save()
            OriginalJSON = myResponses.CreateJSON(TransferJSON)
        End If
    End Sub

    Private Sub LadenToolStripMenuItem_Click(sender As Object, e As EventArgs) Handles LadenToolStripMenuItem.Click
        OpenFileDialog1.InitialDirectory = My.Settings.LastUsedFile
        OpenFileDialog1.ShowDialog()
        If OpenFileDialog1.FileName <> String.Empty Then
            LoadFile(OpenFileDialog1.FileName)
        End If
    End Sub

    Private Sub LoadFile(filename As String)
        Webserver2.OpenFirewall()

        DeSerialize(filename)
        lv1.Items.Clear()
        Dim li As New ListViewItem
        Init = True
        If Not IsNothing(myResponses.event.payload.endpoints) Then


            For Each o As Object In myResponses.event.payload.endpoints
                '       Dim s As String = o.GetClassName
                li = lv1.Items.Add("New item")
                o.lvi = li
                li.Tag = o
                li.Text = o.friendlyName & " (" & o.endpointId & ")"
                If o.enabled = True Then
                    li.Checked = True
                End If
            Next
            My.Settings.LastUsedFile = filename
            My.Settings.Save()
        End If
        OriginalJSON = myResponses.CreateJSON(TransferJSON)
        Init = False

    End Sub
    Private Sub EndeToolStripMenuItem_Click(sender As Object, e As EventArgs) Handles EndeToolStripMenuItem.Click
        '  BackgroundWorker1.CancelAsync()
        Application.Exit()
    End Sub

    Private Sub ToolStripTextBox1_KeyPress(sender As Object, e As KeyPressEventArgs) Handles ToolStripTextBox1.KeyPress
        If (Asc(e.KeyChar) = 8) Or (Asc(e.KeyChar) = 0) Then Exit Sub

        If Asc(e.KeyChar) = 13 Then
            Dim i As Integer = Val(ToolStripTextBox1.Text)
            If i <> 0 Then
                If i <> My.Settings.ListenPort Then
                    Webserver2.StopWebserver()
                    My.Settings.ListenPort = i
                    My.Settings.Save()
                    Webserver2.StartWebServer()
                End If
            End If
            ExtrasToolStripMenuItem.HideDropDown()
        Else
            Dim allowedChars As String = "1234567890"
            If Not allowedChars.Contains(e.KeyChar.ToString.ToLower) Then
                e.KeyChar = ChrW(0)
                e.Handled = True
            End If
        End If
    End Sub

    Private Sub ToolStripTextBox1_Validating(sender As Object, e As CancelEventArgs) Handles ToolStripTextBox1.Validating
        Dim i As Integer = Val(sender.text)
        If i <> 0 Then
            If i <> My.Settings.ListenPort Then
                Webserver2.StopWebserver()
                My.Settings.ListenPort = i
                My.Settings.Save()
                Webserver2.StartWebServer()
            End If
        End If
    End Sub


#End Region


#Region "Form Resize"
    Private Sub lv_EnabledCapabilities_Resize(sender As Object, e As EventArgs) Handles lv_EnabledCapabilities.Resize
        lv_EnabledCapabilities.Columns(0).Width = lv_EnabledCapabilities.Width
    End Sub
#End Region


#Region "HilfsTexte"

    Private Sub lb_functions_GotFocus(sender As Object, e As EventArgs)
        txt_help.Text = "Hier werden alle Eigenschaften deines Gerätes angelegt"
    End Sub
    Private Sub txt_Endpoint_MouseEnter(sender As Object, e As EventArgs) Handles txt_help.MouseEnter
        txt_help.Text = "Die Endpunkt-ID ist eine eindeutige Kennung des Gerätes Sie darf maximal 256 Zeichen lang sein. Erlaubte Zeichen sind alle Buchstaben und Nummern sowie die Sonderzeichen: _ - = # ; : ? @ & ."
    End Sub

    Private Sub txt_manufacturer_MouseEnter(sender As Object, e As EventArgs) Handles txt_manufacturer.MouseEnter
        txt_help.Text = "Hier wird der Hersteller des Gerätes eingetragen (egal welcher)"

    End Sub

    Private Sub txt_description_MouseEnter(sender As Object, e As EventArgs) Handles txt_description.MouseEnter
        txt_help.Text = "Eine kurze Beschreibung des Gerätes (max 128 Zeichen)"
    End Sub

    Private Sub txt_name_MouseEnter(sender As Object, e As EventArgs) Handles txt_name.MouseEnter
        txt_help.Text = "Dies ist der Name zum Benutzen des Gerätes, z.B. Licht Kueche. (max. 128 Zeichen keine Sonderzeichen)"
    End Sub

    Private Sub LV_categ_MouseEnter(sender As Object, e As EventArgs) Handles LV_categ.MouseEnter
        txt_help.Text = "Die Kategorie, unter der das Gerät in der Alexa-App angeteigt wird"
    End Sub




#End Region


#Region "Debug"
    Private Sub Button3_Click(sender As Object, e As EventArgs) Handles Button3.Click
        MyJson = myResponses.CreateJSON(NiceJSON)
        Label8.Text = MyJson
    End Sub

    Private Sub Button4_Click(sender As Object, e As EventArgs) Handles Button4.Click
        Label8.Text = Webserver2.BuildNiceResponseJson()
    End Sub

    Private Sub lv_EnabledCapabilities_SelectedIndexChanged(sender As Object, e As EventArgs) Handles lv_EnabledCapabilities.SelectedIndexChanged
        lv_inputs.Visible = False
        Panel5.Visible = False

        If lv_EnabledCapabilities.SelectedItems.Count Then
            Dim li As ListViewItem = lv_EnabledCapabilities.SelectedItems(0)
            Dim o As Object = li.Tag
            If TypeOf o Is Cls_InputControllerCapability Then
                o.lv = Me.lv_inputs
                lv_inputs.Tag = o
                lv_inputs.Visible = True
                o.FillListView
            ElseIf TypeOf o Is Cls_modeControllerCapability Then
                Panel5.Visible = True
                SelectedModeControllser = o
                Me.txtInstance.DataBindings.Clear()
                Me.txtInstance.DataBindings.Add(New System.Windows.Forms.Binding("Text", SelectedModeControllser, "instance", False, DataSourceUpdateMode.OnPropertyChanged))
                Me.txtFriendlyNames.Text = BuildFriendlyNameText(SelectedModeControllser.capabilityResources.friendlyNames)
                Reinitlv_supportedModes()
            End If
        End If
    End Sub

    Private Sub Reinitlv_supportedModes()
        Dim li As ListViewItem = lv_EnabledCapabilities.SelectedItems(0)

        lv_supportedModes.Items.Clear()
        For Each sm As Cls_SupportedModes In SelectedModeControllser.configuration.supportedModes
            li = lv_supportedModes.Items.Add(sm.value)
            li.Tag = sm
        Next
    End Sub


    Private Sub lv_inputs_ItemChecked(sender As Object, e As ItemCheckedEventArgs) Handles lv_inputs.ItemChecked
        Dim o As Object = lv_inputs.Tag
        o.HandleListviewCheck

    End Sub

    Public Function ReturnLabel8() As String
        Return Label8.Text

    End Function

    Private Sub Button1_Click(sender As Object, e As EventArgs) Handles Button1.Click
        Webserver2.JsonTest = Label8.Text
    End Sub

    Private Sub btnFriendlyNames_Click(sender As Object, e As EventArgs) Handles btnFriendlyNames.Click
        Dim fn As New Frm_FriendlyNames
        fn.lfn = SelectedModeControllser.capabilityResources.friendlyNames
        fn.ShowDialog()
        Me.txtFriendlyNames.Text = BuildFriendlyNameText(SelectedModeControllser.capabilityResources.friendlyNames)
        fn.Dispose()
    End Sub


    Private Function BuildFriendlyNameText(fn As List(Of Cls_FriendlyNames)) As String
        Dim s As String = ""
        For Each i As Cls_FriendlyNames In fn
            If i.type = "text" Then
                s = s & i.value.text
            Else
                s = s & i.value.assetId
            End If
            s = s & ", "
        Next
        Return s
    End Function


    Private Sub txtFriendlyNames_KeyPress(sender As Object, e As KeyPressEventArgs) Handles txtFriendlyNames.KeyPress
        e.Handled = True
    End Sub

    Private Sub Button2_Click(sender As Object, e As EventArgs)

    End Sub

    Private Sub btnDeleteSupportedMode_Click(sender As Object, e As EventArgs) Handles btnDeleteSupportedMode.Click
        If lv_supportedModes.SelectedItems.Count Then
            Dim sm As Cls_SupportedModes
            sm = lv_supportedModes.SelectedItems(0).Tag
            SelectedModeControllser.configuration.supportedModes.Remove(sm)
            Reinitlv_supportedModes()
        End If
    End Sub

    Private Sub lv_supportedModes_SelectedIndexChanged(sender As Object, e As EventArgs) Handles lv_supportedModes.SelectedIndexChanged
        Me.txtInstance.DataBindings.Clear()
        Me.txtInstance.DataBindings.Add(New System.Windows.Forms.Binding("Text", SelectedModeControllser, "instance", False, DataSourceUpdateMode.OnPropertyChanged))

    End Sub

    Private Sub btnNewSupportedMode_Click(sender As Object, e As EventArgs) Handles btnNewSupportedMode.Click
        Dim sm As New Cls_SupportedModes
        Dim nsm As New frm_NewSupportedMode
        nsm.sm = sm
        sm.value = ""
        nsm.Init()
        nsm.ShowDialog()
        If nsm.DialogResult = DialogResult.OK Then
            SelectedModeControllser.configuration.supportedModes.Add(sm)

            Dim fn As New Frm_FriendlyNames
            fn.lfn = sm.modeResources.friendlyNames
            fn.ShowDialog()
            '            Me.txtFriendlyNames.Text = BuildFriendlyNameText(SelectedModeControllser.capabilityResources.friendlyNames)
            fn.Dispose()
            Reinitlv_supportedModes()
        End If
    End Sub

    Private Sub btnEdit_Click(sender As Object, e As EventArgs) Handles btnEdit.Click
        If lv_supportedModes.SelectedItems.Count = 0 Then Exit Sub

        Dim sm As Cls_SupportedModes = lv_supportedModes.SelectedItems(0).Tag
        Dim nsm As New frm_NewSupportedMode
        nsm.sm = sm
        nsm.Init()
        nsm.ShowDialog()
        If nsm.DialogResult = DialogResult.OK Then
            '            SelectedModeControllser.configuration.supportedModes.Add(sm)

            Dim fn As New Frm_FriendlyNames
            fn.lfn = sm.modeResources.friendlyNames
            fn.ShowDialog()
            '            Me.txtFriendlyNames.Text = BuildFriendlyNameText(SelectedModeControllser.capabilityResources.friendlyNames)
            fn.Dispose()
            Reinitlv_supportedModes()
        End If

    End Sub







#End Region
End Class
