﻿Imports System.IO
Imports System.Runtime.Serialization
Imports System.Runtime.Serialization.Formatters.Binary
Imports System.Text.Json

Module Globals

    Public myResponses As Cls_ResponseObjects

    Public AllCategories As New Dictionary(Of String, String)
    Public ImplementedFunctions As New Dictionary(Of String, ClsFunctionTypes)
    Public All_Inputs As New List(Of String)

    Public MyJson As String

    Public NiceJSON As New JsonSerializerOptions
    Public TransferJSON As New JsonSerializerOptions


    Public Sub Init()

        NiceJSON.WriteIndented = True
        NiceJSON.IgnoreNullValues = True
        TransferJSON.IgnoreNullValues = True


        AllCategories.Add("CAMERA", "Kamera")
        AllCategories.Add("CONTACT_SENSOR", "Kontakt-Sensor")
        AllCategories.Add("DOOR", "Tür")
        AllCategories.Add("DOORBELL", "Türklingel")
        AllCategories.Add("FAN", "Lüfter")
        AllCategories.Add("LIGHT", "Licht")
        AllCategories.Add("MICROWAVE", "Microwelle")
        AllCategories.Add("MOTION_SENSOR", "Bewegungsmelder")
        AllCategories.Add("OTHER", "Sonstiges")
        AllCategories.Add("SECURITY_PANEL", "Sicherheitspanel")
        AllCategories.Add("SMARTLOCK", "Verriegelung")
        AllCategories.Add("SMARTPLUG", "Smartplug")
        AllCategories.Add("SPEAKER", "Lautsprecher")
        AllCategories.Add("SWITCH", "Schalter")
        AllCategories.Add("TEMPERATURE_SENSOR", "Temperaturfühler")
        AllCategories.Add("THERMOSTAT", "Thermostat")
        AllCategories.Add("TV", "Fernseher")
        AllCategories.Add("SCENE_TRIGGER", "Scene")
        AllCategories.Add("ACTIVITY_TRIGGER", "Scene mit Reihenfolge")
        AllCategories.Add("INTERIOR_BLIND", "Jalousienen")
        AllCategories.Add("GARAGE_DOOR", "Garagentür")  'nicht in der offiziellen Liste


        All_Inputs.AddRange({"AUX 1", "AUX 2", "AUX 3", "AUX 4", "AUX 5", "AUX 6",
                            "AUX 7", "BLURAY", "CABLE", "CD", "COAX 1", "COAX 2",
                            "COMPOSITE 1", "DVD", "GAME", "HD RADIO", "HDMI 1", "HDMI 2",
                            "HDMI 3", "HDMI 4", "HDMI 5", "HDMI 6", "HDMI 7", "HDMI 8",
                            "HDMI 9", "HDMI 10", "HDMI ARC", "INPUT 1", "INPUT 2",
                            "INPUT 3", "INPUT 4", "INPUT 5", "INPUT 6", "INPUT 7",
                            "INPUT 8", "INPUT 9", "INPUT 10", "IPOD", "LINE 1",
                            "LINE 2", "LINE 3", "LINE 4", "LINE 5", "LINE 6", "LINE 7",
                            "MEDIA PLAYER", "OPTICAL 1", "OPTICAL 2", "PHONO",
                            "PLAYSTATION", "PLAYSTATION 3", "PLAYSTATION 4", "SATELLITE",
                            "SMARTCAST", "TUNER", "TV", "USB DAC", "VIDEO 1", "VIDEO 2",
                            "VIDEO 3", "XBOX"})

        'mode. range und toggle controller können mehrfach eingesetzt werden
        AddImpementedFunction("Cls_BrightnessControllerCapability", "Helligkeits Regler", False)
        AddImpementedFunction("Cls_ChannelControllerCapability", "Kanal Regler", False)
        AddImpementedFunction("Cls_ColorControllerCapability", "Farb Regler", False)
        AddImpementedFunction("Cls_ColorTemperatureControllerCapability", "Farb Temperatur Regler", False)
        AddImpementedFunction("Cls_PowerControllerCapability", "An Aus", False)
        AddImpementedFunction("Cls_PercentageControllerCapability", "Prozent Regler", False)
        AddImpementedFunction("Cls_PowerLevelControllerCapabilty", "Power Level", False)
        AddImpementedFunction("Cls_ThermostatControllerCapability", "Thermostat Regler", False)
        AddImpementedFunction("Cls_InputControllerCapability", "Input Auswahl", False)
        AddImpementedFunction("Cls_ModeControllerCapability", "Mode Regler", True)
        '        AddImpementedFunction("Cls_NoneCapability", "Ende", True)



    End Sub

    Private Sub AddImpementedFunction(ClassName As String, Displayname As String, MultiUsable As Boolean)
        ImplementedFunctions.Add(ClassName, New ClsFunctionTypes(Displayname, ClassName, MultiUsable))
    End Sub








    Public Sub Serialize(file As String)

        Using fileStream As Stream = New FileStream(file, FileMode.Create, FileAccess.Write, FileShare.None)
            Dim formatter As IFormatter = New BinaryFormatter
            formatter.Serialize(fileStream, myResponses)
        End Using

    End Sub

    Public Sub DeSerialize(file As String)
        myResponses = Nothing
        Using FileStream As Stream = New FileStream(file, FileMode.Open,
                                 FileAccess.Read, FileShare.Read)
            Dim formatter As IFormatter = New BinaryFormatter
            myResponses = DirectCast(formatter.Deserialize(FileStream), Cls_ResponseObjects)
        End Using

    End Sub


    Public Sub test(mc As Cls_ModeControllerCapability)
        'mc.Instance = "Wohnzimmer.Rollo"
        '' Add capabilityResources
        'mc.capabilityResources.friendlyNames.Add(New Cls_FriendlyNames(e_FriendlyName_Type.text, "Rollos"))
        'Dim sm1 As New Cls_SupportedModes
        'sm1.value = "Rollo.up"
        'sm1.modeResources.friendlyNames.Add(New Cls_FriendlyNames(e_FriendlyName_Type.text, "oeffnen"))
        'mc.configuration.supportedModes.Add(sm1)
        'Dim sm2 As New Cls_SupportedModes
        'sm2.value = "Rollo.down"
        'sm2.modeResources.friendlyNames.Add(New Cls_FriendlyNames(e_FriendlyName_Type.text, "schliessen"))
        'mc.configuration.supportedModes.Add(sm2)
    End Sub







End Module
