﻿Imports System.Text.Json

<Serializable()>
Public Class Cls_Endpoint

    '**************************************************
    'internal Property helper vars
    '**************************************************
    Private _friendlyName As String
    Private _endpointId As String
    Private _enabled As Boolean = False
    Private _uid As Guid = Guid.NewGuid()

    <NonSerialized()>
    Public lvi As ListViewItem
    Public mdisplayCategories As New Dictionary(Of String, String)

    '**************************************************
    'JSON Properties
    '**************************************************
    Property endpointId As String
        Get
            Return _endpointId
        End Get
        Set
            _endpointId = Value
            If Not IsNothing(lvi) Then
                lvi.Text = friendlyName & " (" & _endpointId & ")"
            End If
        End Set
    End Property
    Public Property manufacturerName As String
    Public Property description As String
    Property friendlyName As String
        Get
            Return _friendlyName
        End Get
        Set
            _friendlyName = Value
            If Not IsNothing(lvi) Then
                lvi.Text = friendlyName & " (" & _endpointId & ")"
            End If
        End Set
    End Property
    Property displayCategories As List(Of String)

        Get
            Dim ReturnList As New List(Of String)
            For Each kv As KeyValuePair(Of String, String) In mdisplayCategories
                ReturnList.Add(kv.Key)
            Next
            Return ReturnList
        End Get

        Set(value As List(Of String))
            mdisplayCategories.Clear()
            For Each s As String In value
                mdisplayCategories.Add(s, AllCategories(s))
            Next
        End Set

    End Property
    Public Property capabilities As New List(Of Object)



    '**************************************************
    'Binary Serialisation Properties
    '**************************************************
    <Serialization.JsonIgnore>
    Public Property enabled As Boolean
        Get
            Return _enabled
        End Get
        Set
            _enabled = Value
        End Set
    End Property

    <Serialization.JsonIgnore>
    Public Property uid As Guid
        Get
            Return _uid
        End Get
        Set
            _uid = Value
        End Set
    End Property


    Public Sub SetEnable(e As Boolean)
        enabled = e
    End Sub

End Class
